'''
Gizmo(QP) Web Framework - http://gizmojo.org/
------------------------------------------------------------------------------
Copyright (C) 2007 Mario Ruggier, mario@ruggier.org
Licensed under the Open Software License version 3.0
'''
__url__ = "$URL: svn://gizmojo.org/pub/gz/trunk/demo/gzdemo/pages/basics.py $"
# $begin{code}
__revision__ = "$Id: basics.py 964 2008-03-17 14:03:29Z mario $"

from gz.pub.common import get_publisher, page, get_dhi
from gz.fill.exportable import X
from gz.fill.directory import Directory

class BasicsDir(Directory):

    exportables = [
        # X(component, attribute, crumb, title, allow=None, dhi=None)
        X('', 'index', 'Basics', 'Some Basics'), 
        X('request', 'request', 'Request', 'HTTP Request'),
        X('session', 'session', 'Session', 'Persistent User Session'),
        X('json', 'json', 'JSON Responses', 'JSON Responses'),
        X('json-response-example', 'json_response_example', None, 
                                                'Example of a JSON Response'),
        X('http-errors', 'http_errors', 'HTTP Errors', 'HTTP Errors'),
        X('not-authorized', 'unauthorized', None, '401, Unauthorized'),
        X('non-existant', 'not_found', None, '404, Not Found'),
        X('none', 'none_not_found', None, '404, Not Found'),
    ]
    
    def index(self):
        return page(get_dhi().x.title, template='basics.html')

    def request(self):
        return page(get_dhi().x.title, template='basics_request.html')

    def session(self):
        return page(get_dhi().x.title, template='basics_session.html')

    
    def json(self):
        return page(get_dhi().x.title, template='basics_json.html')

    def json_response_example(self):
        get_publisher().json_respond_now(dict(a=1, b='two', c='see'))

    
    def http_errors(self):
        return page(get_dhi().x.title, template='basics_errors.html')
        
    def unauthorized(self):
        return get_publisher().unauthorized()
        
    def not_found(self):
        return get_publisher().not_found("'non-existant'?")

    def none_not_found(self):
        return None
