'''
Gizmo(QP) Web Framework - http://gizmojo.org/
------------------------------------------------------------------------------
Copyright (C) 2007 Mario Ruggier, mario@ruggier.org
Licensed under the Open Software License version 3.0
'''
__url__ = "$URL: svn://gizmojo.org/pub/gz/trunk/demo/gzdemo/pages/gizmos.py $"
# $begin{code}
__revision__ = "$Id: gizmos.py 964 2008-03-17 14:03:29Z mario $"

from gz.pub.common import page, get_dhi
from gz.fill.exportable import X
from gz.fill.directory import Directory

class GizmosDir(Directory):
    
    exportables = [
        # X(component, attribute, crumb, title, allow=None, dhi=None)
        X('', 'index', 'Gizmos', 'Gizmo Objects'),
        X('collapsable', 'collapsable', 'Collapsable', 'Collapsable'),
        X('tabbed', 'tabbed', 'Tabbed', 'Tabbed'),
        X('stbl', 'stbl', 'Stbl', 'Stbl'),
        X('scrambling', 'scrambling', 'ScramblingLinks', 'ScramblingLinks'),
        X('suckerfish', 'suckerfish', 'Suckerfish', 'Suckerfish Trail Menus'),
        X('interacting', 'interacting', 'Interacting...', 
                                                'Interaction between Gizmos'),
    ]
    
    def index(self):
        return page(get_dhi().x.title, template='gizmos_.html')
    
    def collapsable(self):
        return page(get_dhi().x.title, template='gizmos_collapsable.html')
    
    def tabbed(self):
        return page(get_dhi().x.title, template='gizmos_tabbed.html')

    def stbl(self):
        return page(get_dhi().x.title, template='gizmos_stbl.html')
    
    def scrambling(self):
        return page(get_dhi().x.title, template='gizmos_scrambling.html')
    
    def suckerfish(self):
        return page(get_dhi().x.title, template='gizmos_suckerfish.html')

    def interacting(self):
        return page(get_dhi().x.title, template='gizmos_interacting.html')
