'''
Gizmo(QP) Web Framework - http://gizmojo.org/
------------------------------------------------------------------------------
Copyright (C) 2007 Mario Ruggier, mario@ruggier.org
Licensed under the Open Software License version 3.0
'''
__url__ = "$URL: svn://gizmojo.org/pub/gz/trunk/demo/hellopluto/slash.py $"
# $begin{code}
__revision__ = "$Id: slash.py 964 2008-03-17 14:03:29Z mario $"

from gz.fill.directory import Directory
from gz.fill.exportable import X
from gz.fill.login_dir import LoginDir
from gz.skin.evoque_templating import EvoqueTemplating
from gz.pub.durus_publisher import DurusPublisher
from gz.pub.common import page

class SitePublisher(DurusPublisher):
    
    configuration = dict(
        durus_address=('127.0.0.1', 5017),
        scgi_address=('127.0.0.1', 7017),
        http_address=('', 8017),
        as_https_address=('127.0.0.1', 9017),
        https_address=('127.0.0.1', 10017),
        max_children=2,
        secure=False, 
        url_paths = { 
            'login': '/login/', 
            'logout': '/login/logout', 
        }, 
        file_paths = { 
            'templates':'', 
        },
    )
    
    skin_class = EvoqueTemplating
    
    def __init__(self, connection=None, site=None, **kw):
        DurusPublisher.__init__(self, connection=connection, site=site, **kw)
        skin = self.skin
        skin.set_domain(self.get_file_path_for('templates'))
        skin.setup_globals()
        skin.domain.get_collection().set_template("", "template.html", 
                from_string=False)
        skin.aliases["login"] = ""
            
    def ensure_database_initialized(self):
        super(SitePublisher, self).ensure_database_initialized()
        if self.get_users().get('pluto') is None:
            pluto = self.get_users()['pluto'] = self.create_user('pluto')
            pluto.set_password('pluto')
            self.commit() 
    

class SiteDirectory(Directory):
    
    exportables = [
        X('', 'index', 'Kuiper Belt', 'Kuiper Belt'), 
        X('pluto', 'pluto', 'Pluto Touchdown', 'Planet Pluto Touchdown', 
                                                        ('authenticated',)),
        X('login/', 'login', None, 'Login'),
    ]
    
    login = LoginDir()
    
    def index(self):
        return page(self.get_x().title,
            'OK, you made it as far as the Kuiper Belt!')
    
    def pluto(self):
        return page(self.get_x().title,
            "Hello Pluto! You can't imagine how heart-warming it is to see you!")
    
