'''
Gizmo(QP) Web Framework - http://gizmojo.org/
------------------------------------------------------------------------------
Copyright (C) 2007 Mario Ruggier, mario@ruggier.org
Licensed under the Open Software License version 3.0
'''
__url__ = "$URL: svn://gizmojo.org/pub/gz/trunk/fill/admin.py $"
__revision__ = "$Id: admin.py 975 2008-03-19 10:44:16Z mario $"

from qpy import h8
from gz.pub.common import get_publisher, get_dhi, page
from directory import Directory
from exportable import X
from durus_dir import DurusDir
from admin_users import AdminUsers
    
class Admin(Directory):

    exportables = [
        X('', 'index', 'Admin', 'Admin', ),
        X('users/', 'users', 'Users', 'Manage Users'),
        X('db/', 'database', 'Browse Durus', 'Browse Durus Database'),
        X('pack', 'pack', 'Pack Durus', 'Remove Durus Database History'),
    ]
    #+ history db browser

    users = AdminUsers()
    database = DurusDir()

    def index(self):
        dhi = get_dhi()
        return page(dhi.x.title,
            h8('<p>%s</p>') %( '''
Follow the appropriate Admin sub-menu item -- 
if no sub-menu is visible, then ensure (you and/or the site maintainer)
that the templates being used for these Admin pages includes a sub-menu. 
            ''')
        )

    def pack(self):
        publisher = get_publisher()
        publisher.get_connection().pack()
        publisher.redirect('.')
