'''
Gizmo(QP) Web Framework - http://gizmojo.org/
------------------------------------------------------------------------------
Copyright (C) 2007 Mario Ruggier, mario@ruggier.org
Licensed under the Open Software License version 3.0
'''
__url__ = "$URL: svn://gizmojo.org/pub/gz/trunk/fill/doctypes.py $"
__revision__ = "$Id: doctypes.py 964 2008-03-17 14:03:29Z mario $"

from qpy import h8

def doctype(key='XHTML_10_Transitional'):
    return _doctypes_map[key]

# From: http://www.alistapart.com/stories/doctype/

_doctypes_map = dict(

    HTML_401_Strict = h8(
'<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"'
' "http://www.w3.org/TR/html4/strict.dtd">\n'),

    HTML_401_Transitional = h8(
'<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"'
' "http://www.w3.org/TR/html4/loose.dtd">\n'),

    HTML_401_Frameset = h8(
'<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN"'
' "http://www.w3.org/TR/html4/frameset.dtd">\n'),

    XHTML_10_Strict = h8(
'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"'
' "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">\n'),

    XHTML_10_Transitional = h8(        
'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"'
' "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n'),

    XHTML_10_Frameset = h8(        
'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN"'
' "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">\n'),

    XHTML_11_DTD = h8(
'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"'
' "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">\n'),

)

#
