'''
Gizmo(QP) Web Framework - http://gizmojo.org/
------------------------------------------------------------------------------
Copyright (C) 2007 Mario Ruggier, mario@ruggier.org
Licensed under the Open Software License version 3.0
'''
__url__ = "$URL: svn://gizmojo.org/pub/gz/trunk/fill/durus_dir.py $"
__revision__ = "$Id: durus_dir.py 983 2008-03-19 15:08:49Z mario $"

from qpy import h8
from qp.lib.spec import persistent_vars
from gz.pub.common import get_publisher, page
from gz.fill.directory import Directory
from gz.fill.exportable import X
from gz.fill.debug import format_p_obj
from gz.skin import html

class DurusDir(Directory):

    def __init__(self, obj=None, connection=None):
        self.obj = obj
        self.connection = connection
        self.component = None
        
    def get_exportables(self):
        yield X('', 'index', repr(self.get_object()), None)

    def get_object(self):
        if self.obj is None:
            if self.connection is None:
                self.connection = get_publisher().get_connection()
            self.obj = self.connection.get_root()
        return self.obj

    def index(self):
        return self.display(self.get_object())

    def _q_lookup(self, component):
        self.component = component
        if self.connection is None:
            self.connection = self.obj._p_connection
        try:
            return self.__class__(self.connection.get(int(component)))
        except ValueError:
            return None

    def display(self, obj):
        return page(
            "Object: %s" % obj._p_format_oid(),
            h8.from_list((
                html.div(str(obj), style="font-weight:bold"),
                format_p_obj(persistent_vars(obj), 
                        recurse_p_attrs=0, link_p_attrs=True))),
            template='durus')

#

