'''
Gizmo(QP) Web Framework - http://gizmojo.org/
------------------------------------------------------------------------------
Copyright (C) 2007 Mario Ruggier, mario@ruggier.org
Licensed under the Open Software License version 3.0
'''
__url__ = "$URL: svn://gizmojo.org/pub/gz/trunk/lib/utils.py $"
__revision__ = "$Id: utils.py 964 2008-03-17 14:03:29Z mario $"


def get_allow_x_extension(allow, extension):
    ''' (allow:tuple, extension:str) -> tuple
    '''
    allow_x = []
    do_not_change = ('administrator', 'non-administrator')
    if allow:
        for permission in allow:
            if permission not in do_not_change:
                allow_x.append('%s_%s' % (permission, extension))
            else:
                allow_x.append(permission)    
    return tuple(allow_x)
    

def get_publisher_for_site(name):
    ''' (str) -> Publisher
    Get a Publisher instance for Site(name) 
    For utility scripts (that are not qp web processes) 
    '''
    from qp.pub.common import get_publisher
    assert get_publisher() is None
    from qp.lib.site import Site
    site = Site(name)
    return site.get_publisher()

