#!/usr/bin/env python
'''
Gizmo(QP) Web Framework - http://gizmojo.org/
------------------------------------------------------------------------------
Copyright (C) 2007 Mario Ruggier, mario@ruggier.org
Licensed under the Open Software License version 3.0
'''
__url__ = "$URL: svn://gizmojo.org/pub/gz/trunk/setup.py $"
__revision__ = "$Id: setup.py 979 2008-03-19 14:33:16Z mario $"

from os import curdir
from distutils.core import setup
try:
    from qpy.setup import qpy_build_py
except ImportError:
    print "Please install Qpy first."
    raise SystemExit

from __init__ import __version__

setup( 
    name = 'gz',
    version = __version__,
    description = 'Gizmo(QP) extensions to the QP Web Framework',
    author = 'Mario Ruggier', 
    author_email = 'mario@ruggier.org', 
    url = 'http://gizmojo.org/',
    license = 'Open Software License version 3.0',
    cmdclass= { 'build_py': qpy_build_py },
    package_dir=dict(gz=curdir),
    packages = [
        'gz',
        'gz.fill',
        'gz.gizmo',
        'gz.lib',
        'gz.pub',
        'gz.skin',
    ], 
    package_data = { 
        'gz.gizmo': [
            'assets/*.css', 
            'assets/*.js', 
            'assets/*.gif', 
            'assets/*.png', 
            'assets/MochiKit/*.js',
        ], 
    },
    platforms = ['Python >= 2.4'],
    long_description=("Gizmo(QP) extends the QP Web Framework adding "
        "functionality to facilitate building rich and exacting "
        "web interfaces."),
)
